import Hash from "./Hash";
export declare type Listener<T> = (key: any, value: T) => any;
export default class Cache<T> {
    enabled: boolean;
    values: Hash<T>;
    changeListeners: Listener<T>[];
    destroyListeners: Listener<T>[];
    get(key: string): T;
    set(key: string, value: T): T;
    destroy(key: string): void;
    clear(): void;
    onChange(callback: Listener<T>): void;
    protected emitChange(key: string, value: T): void;
    onDestroy(callback: Listener<T>): void;
    protected emitDestroy(key: string): void;
}
